//+------------------------------------------------------------------+
//|   #SpudFibo.mq4
//+------------------------------------------------------------------+
#property  indicator_chart_window
//----
extern string note1="Fibonacci colors";
extern color UpperFiboColor=LightBlue;
extern color MainFiboColor=Green;
extern color LowerFiboColor=DodgerBlue;
extern string note2="Draw main Fibonacci lines?";
extern bool  InnerFibs=true;
//----
double HiPrice, LoPrice, Range;
datetime StartTime;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("FiboUp");
   ObjectDelete("FiboDn");
   ObjectDelete("FiboIn");
   return(0);
  }
//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+
int DrawFibo()
  {
   if(ObjectFind("FiboUp")==-1)
      ObjectCreate("FiboUp",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
   else
     {
      ObjectSet("FiboUp",OBJPROP_TIME2, StartTime);
      ObjectSet("FiboUp",OBJPROP_TIME1, StartTime);
      ObjectSet("FiboUp",OBJPROP_PRICE1,HiPrice+Range);
      ObjectSet("FiboUp",OBJPROP_PRICE2,HiPrice);
     }
   ObjectSet("FiboUp",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUp",OBJPROP_FIBOLEVELS,13);
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+0,0.0);   ObjectSetFiboDescription("FiboUp",0,"-%$");
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+1,0.17);   ObjectSetFiboDescription("FiboUp",1,"IntraWeek Short Stop -%$");
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+2,0.34);   ObjectSetFiboDescription("FiboUp",2," Long Target 1 -%$");
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+3,0.55);   ObjectSetFiboDescription("FiboUp",3," Long Target 2 -%$");
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+4,0.764);   ObjectSetFiboDescription("FiboUp",4," Long Target 3 -%$");
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+5,1.764);   ObjectSetFiboDescription("FiboUp",5," Long Target 4 -%$");
   ObjectSet("FiboUp",OBJPROP_RAY,true);
   ObjectSet("FiboUp",OBJPROP_BACK,true);
   if(ObjectFind("FiboDn")==-1)
      ObjectCreate("FiboDn",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
   else
     {
      ObjectSet("FiboDn",OBJPROP_TIME2, StartTime);
      ObjectSet("FiboDn",OBJPROP_TIME1, StartTime);
      ObjectSet("FiboDn",OBJPROP_PRICE1,LoPrice-Range);
      ObjectSet("FiboDn",OBJPROP_PRICE2,LoPrice);
     }
   ObjectSet("FiboDn",OBJPROP_LEVELCOLOR,LowerFiboColor);
   ObjectSet("FiboDn",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+0,0.0);   ObjectSetFiboDescription("FiboDn",0,"-%$");
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+1,0.17);   ObjectSetFiboDescription("FiboDn",1,"IntraWeek Long Stop -%$");
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+2,0.34);   ObjectSetFiboDescription("FiboDn",2," Short Target 1 -%$");
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+3,0.55);   ObjectSetFiboDescription("FiboDn",3," Short Target 2 -%$");
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+4,0.764);   ObjectSetFiboDescription("FiboDn",4," Short Target 3 -%$");
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+5,1.764);   ObjectSetFiboDescription("FiboDn",5," Short Target 4 -%$");
   ObjectSet("FiboDn",OBJPROP_RAY,true);
   ObjectSet("FiboDn",OBJPROP_BACK,true);
   if(InnerFibs)
     {
      if(ObjectFind("FiboIn")==-1)
         ObjectCreate("FiboIn",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_W1*60,LoPrice);
      else
        {
         ObjectSet("FiboIn",OBJPROP_TIME2, StartTime);
         ObjectSet("FiboIn",OBJPROP_TIME1, StartTime+PERIOD_W1*60);
         ObjectSet("FiboIn",OBJPROP_PRICE1,HiPrice);
         ObjectSet("FiboIn",OBJPROP_PRICE2,LoPrice);
        }
      ObjectSet("FiboIn",OBJPROP_LEVELCOLOR,MainFiboColor);
      ObjectSet("FiboIn",OBJPROP_FIBOLEVELS,7);
      ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+0,0.0);     ObjectSetFiboDescription("FiboIn",0,"LastWeek Low -%$");
      ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+1,0.191);   ObjectSetFiboDescription("FiboIn",1," R1 -%$");
      //ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+2,0.382);   ObjectSetFiboDescription("FiboIn",2,"IntraWeek Short -%$");
      ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+3,0.500);   ObjectSetFiboDescription("FiboIn",3," Pivot -%$");
      //ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+4,0.618);   ObjectSetFiboDescription("FiboIn",4,"IntraWeek Long -%$");
      ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+5,0.809);   ObjectSetFiboDescription("FiboIn",5," S1 -%$");
      ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+6,1.000);   ObjectSetFiboDescription("FiboIn",6,"LastWeek High -%$");
      ObjectSet("FiboIn",OBJPROP_RAY,true);
      ObjectSet("FiboIn",OBJPROP_BACK,true);
     }
   else
      ObjectDelete("FiboIn");
  }
//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+
int start()
  {
   int shift  =iBarShift(NULL,PERIOD_W1,Time[0]) + 1;   // yesterday
   HiPrice     =iHigh(NULL,PERIOD_W1,shift);
   LoPrice     =iLow (NULL,PERIOD_W1,shift);
   StartTime  =iTime(NULL,PERIOD_W1,shift);
   if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
     {//Add fridays high and low
     }
   Range=HiPrice-LoPrice;
   DrawFibo();
//----
   return(0);
  }
//+------------------------------------------------------------------+

